package {
	import org.flixel.FlxG;
	import org.flixel.FlxObject;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;

	/**
	 * @author Yori Kvitchko
	 */
	public class ChatBubble extends FlxSprite {
		/*
		 * Point at which the arrow of the bubble points to
		 */
		private var _focus:FlxObject;
		/*
		 * FlxText representing the text of the bubble
		 */
		private var _text:FlxText;
		/*
		 * Timer for determining fade time
		 */
		private var _fadeTimer:Number;
		
		[Embed(source="../data/chatbubble.png")] 
		private var ImgBubble:Class;
		
		public function ChatBubble(Focus:FlxObject) {
			_fadeTimer = 0;
			_focus = Focus;
			_text = new FlxText(0, 0, 40, "");
			
			super(0, 0, ImgBubble);
			
			_text.x = x;
			_text.y = y;
			
			solid = false;
			fixed = true;
			moves = false;
		}

		override public function update():void {
			_fadeTimer -= FlxG.elapsed;
			
			if(_fadeTimer < 0) {
				_text.text = "";
				visible = false;
			}
			
			super.update();
			_text.update();
			
			x = _focus.x + _focus.origin.x;
			y = _focus.y + _focus.origin.y - height;
			_text.x = x + 15;
			_text.y = y + 10;
		}

		override public function render():void {
			super.render();
			_text.render();
		}
		
		public function showSpeech(Text:String, Duration:Number):void {
			visible = true;
			_text.text = Text;
			_fadeTimer = Duration;
		}
	}
}
