package
{
	import org.flixel.*;

	 // Enemy
	public class Enemy extends FlxSprite
	{
		
		[Embed(source='../data/enemy_20.png')] 
		private var ImgEnemy1:Class;
		
		public var _enemySprite:FlxSprite;
		private var _playerShip:Ship;
		
		/*
		 * Vector for storing list of bullets
		 */
		private var _bullets:FlxGroup;
			/*
		 * Index of next available bullet
		 */
		private var _bulletIndex:uint;
		/*
		 * Timer used for counting down until the next bullet can be fired
		 */
		private var _bulletTimer:Number;
		/*
		 * Fire interval for bullets
		 */
		private const _bulletInterval:Number = 0.75;
		
		public function Enemy(X:Number = 0, Y:Number = 0, playerShip:Ship = null):void
		{
			super(X,Y,ImgEnemy1);
			
			//reference to player's ship in order to attack it
			this._playerShip = playerShip;
    		
			_enemySprite = new FlxSprite(X, Y);
			_enemySprite.width = 16;
			_enemySprite.height = 16;
			_enemySprite.offset.x = 1;
			_enemySprite.offset.y = 1;
			_enemySprite.loadGraphic(ImgEnemy1);
			_enemySprite.scale=new FlxPoint(1,1);
			_enemySprite.moves=true;
			_enemySprite.solid=true;
			
			// Initialize Bullets Group
			_bullets = new FlxGroup(); 
			// Bullets
			_bulletTimer = _bulletInterval;
			var s:FlxSprite;
			for (var i : int = 0; i < 30; i++) {
				s = new FlxSprite(-100, -100);
				s.createGraphic(5, 5);
				_bullets.add(s);
			}
			PlayState(FlxG.state).add(_bullets);

   		}
		
		override public function update():void 
		{
			//Timers
			_bulletTimer -= FlxG.elapsed;
			
			velocity.x=0;
			velocity.y=0;
			
			//Make enemy turn and face player
			angle=0;
			var Xdiff:Number = _playerShip.x-x;
			var Ydiff:Number = _playerShip.y-y;
			angle = 90+Math.atan2(Ydiff, Xdiff) * 180 / Math.PI;
			
			//Move towards player's ship (attack) - but dont get too close! - currently it gets too close - NEED TO FIX
			if (Math.abs(Xdiff) >100 && Math.abs(Ydiff) >100)
			{
				if(x<_playerShip.x)
				{
					x+=5		
				}
				else if(x>_playerShip.x)
				{
					x-=5;
				}	
				
				if(y<_playerShip.y)
				{
					y+=5;
				}
				else if(y>_playerShip.y)
				{
					y-=5;
				}	
			}
			//Stop moving if close to player
			else
			{
				velocity.x=0;
				velocity.y=0;
			}
			
			//Fire bullets on player
			if(_bulletTimer <= 0) {
				var b:FlxSprite = _bullets.members[_bulletIndex];	//Figure out which bullet to fire
				b.reset(x + (_enemySprite.width - b.width) / 2, y + (_enemySprite.height - b.height) / 2);
				b.angle = angle-90;
				b.velocity = FlxU.rotatePoint(150, 0, 0, 0, b.angle);
				b.velocity.x += velocity.x;
				b.velocity.y += velocity.y;
				_bulletIndex++; 
				if(_bulletIndex >= _bullets.members.length) //And check to see if we have too many
					_bulletIndex = 0; //If we did just reset.
				_bulletTimer = _bulletInterval; //Reset bullet timer to interval
			}
			
			super.update();
		}
	}
}