package {
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;

	public class MenuState extends FlxState {

		[Embed(source="../data/circles.png")] 
		private var ImgCircle:Class;

		
		private var _circleButton1:FlxSprite;
		private var _circleButton2:FlxSprite;
		private var _circleButton3:FlxSprite;

		private var _t1:FlxText;
		private var _t2:FlxText;

		
		
		override public function create():void {
			// adding circle buttons (FlxSprite) onto the screen
			_circleButton1 = new FlxSprite(130, 70);
			_circleButton1.loadGraphic(ImgCircle, true);
			_circleButton1.addAnimation("on", [0], 0); 
			_circleButton1.addAnimation("off", [1], 0);
			add(_circleButton1);
			
			_circleButton2 = new FlxSprite(430, 180);
			_circleButton2.loadGraphic(ImgCircle, true);
			_circleButton2.addAnimation("on", [0], 0); 
			_circleButton2.addAnimation("off", [1], 0);
			add(_circleButton2);
			
			
			_circleButton3 = new FlxSprite(230, 320);
			_circleButton3.loadGraphic(ImgCircle, true);
			_circleButton3.addAnimation("on", [0], 0); 
			_circleButton3.addAnimation("off", [1], 0);
			add(_circleButton3);
			
			_t1 = new FlxText(130 + 7, 70 + 25, 50, "Play");
			_t1.alignment = "center";
			add(_t1);
			FlxG.mouse.show();
		}

		
		
		override public function update():void {
			
			if(_circleButton1.overlaps(FlxG.mouse.cursor)) {
				onCircle1();	
			}
			else if(_circleButton2.overlaps(FlxG.mouse.cursor)) {
				onCircle2();	
			}
			else if(_circleButton3.overlaps(FlxG.mouse.cursor)) {
				onCircle3();	
			} else {
				resetCircles();	
			}
			
			super.update();
		}

		private function onCircle1():void {
			_circleButton1.play("off");
			if(FlxG.mouse.justPressed()) {
				FlxG.state = new PlayState();
			}
		}

		private function onCircle2():void {
			_circleButton2.play("off");
		}

		private function onCircle3():void {
			_circleButton3.play("off");
		}

		private function resetCircles():void {
			_circleButton1.play("on");
			_circleButton2.play("on");
			_circleButton3.play("on");
		}

		private function onText1():void {
		}
	}
}

