package {
import org.flixel.*;
import flash.geom.Rectangle;
//import flash.geom.Point;
import flash.display.BitmapData;

public class Radar extends FlxSprite {

  [Embed(source='../data/ship.png')]
private var ImgShip:Class;
  
  private var sv:SpaceView;
  private var ship:FlxSprite;
  // DISPLAY dimensions
  protected var W:Number,H:Number;
  protected const SCALE:Number = .1;

  // ship coords, updated
  private var shipX:Number=0, shipY:Number=0;
  
  public function Radar(sv:SpaceView):void {
    W = SCALE*sv.W;
    H = SCALE*sv.H;

    super(640-W-10, 10);
    this.sv = sv;
    
    scrollFactor = new FlxPoint(0,0);

    ship = new FlxSprite(0,0);
    ship.loadGraphic(ImgShip, false, false, 110, 162);
    ship.scale.x=ship.scale.y = SCALE;
  }


  private function obj2rect(o:FlxObject):Rectangle {
    
    return new Rectangle(W/2+SCALE*(o.x-shipX),
			 H/2+SCALE*(o.y-shipY),
			 Math.ceil(SCALE*o.width),
			 Math.ceil(SCALE*o.height));
  }
  
  override public function update():void {
    var p:BitmapData = new BitmapData(W, H, true, 0x337700FF);

    shipX = sv._ship.x;
    shipY = sv._ship.y;

    // moving radar, not good
    //x = 640-10-(SCALE*shipX);
    //y = 100-(SCALE*shipY);
    
    p.fillRect(new Rectangle(W/2-SCALE*shipX,H/2-SCALE*shipY,W,H), 0x33FFFF44);

    for each (var obj:FlxObject in sv._enemies.members) {
	if (obj.exists) p.fillRect(obj2rect(obj), 0x33FFFFFF);
      }

    for each (obj in sv._objects.members) {
	if (obj.exists) p.fillRect(obj2rect(obj), 0x99FF33FF);
      }

    p.fillRect(obj2rect(sv._goal), 0x9933FF77);
    

    pixels = p;

    ship.angle = sv._ship.angle;
    draw(ship, (W-ship.width)/2, (H-ship.height)/2);
  }
  
}
}