package {
import org.flixel.*;

//This is the class used for all the different asteroid sizes
public class Rock extends FlxSprite
{
  static public var group:FlxGroup;
		
[Embed(source="../data/rock2.png")] public var ImgRock:Class;
		
  //Asteroid constructor - doesn't do much since
  // we want to be able to easily recycle asteroids later...
  public function Rock()  {
    super();

    antialiasing = true; //Smooth rotations
  }

  public function alterBoundingBox(s:Number=0.55):void {
    width = width*s;
    height = height*s;
    offset.x = (frameWidth - width) / 2;
    offset.y = (frameHeight - height) / 2;
  }
  
  //This function actually creates the asteroid
  public function create(X:int=0,Y:int=0):Rock {
    
    //This function can be used to reset or revive an asteroid too, so flip all these flags back on
    exists = true;
    visible = true;
    active = true;
    solid = true;
    fixed = true;

    
    loadGraphic(ImgRock);
    alterBoundingBox(.8);
    
    
    //Set the asteroids a-rotatin' at a random speed (looks neat)
    angularVelocity = FlxU.random()*120 - 60;
    angle = FlxU.random()*360;
		
    x = X;
    y = Y;

    return this;
  }
		
  override public function kill():void  {
    super.kill();
  }
}
}